searchNodes=[{"doc":"Oauth2MetadataUpdater dynamically loads metadata (lazy-loading) and keeps it in memory for further access. Examples: It Implements the following standards: RFC8414 - OAuth 2.0 Authorization Server Metadata - Except section 2.1 ( Signed Authorization Server Metadata ) OpenID Connect Discovery 1.0 incorporating errata set 1 - Except section 2 The following functions accept the following options: suffix : the well-know URI suffix as documented in the IANA registry . Defaults to &quot;openid-configuration&quot; refresh_interval : the number of seconds to keep metadata in cache before it is fetched again. Defaults to 3600 seconds min_refresh_interval : the delay before Oauth2MetadataUpdater will try to fetch metadata of an issuer again. It is intended to prevent fetching storms when the metadata is unavailable. Defaults to 10 seconds on_refresh_failure : determines the behaviour of Oauth2MetadataUpdater when the issuer metadata becomes unavailable: :keep_metadata will keep the metadata in the cache, :discard will delete the metadata. Defaults to :keep_metadata :tesla_middlewares : Tesla middlewares to add to the outgoing request url_construction : :standard (default) or :non_standard_append . Given the issuer &quot;https://www.example.com/auth&quot; the result URI would be: :standard : &quot;https://www.example.com/.well-known/oauth-authorization-server/auth&quot; :non_standard_append : &quot;https://www.example.com/auth/.well-known/oauth-authorization-server&quot; validation : in addition to the mandatory metadata values of the OAuth2 specification, OpenID Connect makes the jwks_uri , subject_types_supported and id_token_signing_alg_values_supported values mandatory. This option determines against which standard to validate: :oauth2 or :oidc . Defaults to :oidc The :suffix , :on_refresh_failure , :url_construction , :validation options shall be used unchanged for a given issuer between multiple calls, otherwise an exception will be raised. Note that OAuth2 and OpenID Connect default values are automatically added to the responses.","ref":"Oauth2MetadataUpdater.html","title":"Oauth2MetadataUpdater","type":"module"},{"doc":"Returns {:ok, map_of_all_values} of the metadata of an issuer, or {:error, error} if it could not be retrieved or if validation failed. Example iex&gt; Oauth2MetadataUpdater . get_metadata ( &quot;https://auth.login.yahoo.co.jp/yconnect/v2&quot; , suffix : &quot;openid-configuration&quot; , url_construction : :non_standard_append ) { :ok , %{ &quot;authorization_endpoint&quot; =&gt; &quot;https://auth.login.yahoo.co.jp/yconnect/v2/authorization&quot; , &quot;claims_locales_supported&quot; =&gt; [ &quot;ja-JP&quot; ] , &quot;claims_supported&quot; =&gt; [ &quot;sub&quot; , &quot;name&quot; , &quot;given_name&quot; , &quot;family_name&quot; , &quot;email&quot; , &quot;email_verified&quot; , &quot;gender&quot; , &quot;birthdate&quot; , &quot;zoneinfo&quot; , &quot;locale&quot; , &quot;address&quot; , &quot;iss&quot; , &quot;aud&quot; , &quot;exp&quot; , &quot;iat&quot; , &quot;nickname&quot; , &quot;picture&quot; ] , &quot;display_values_supported&quot; =&gt; [ &quot;page&quot; , &quot;popup&quot; , &quot;touch&quot; ] , &quot;grant_types_supported&quot; =&gt; [ &quot;authorization_code&quot; , &quot;implicit&quot; ] , &quot;id_token_signing_alg_values_supported&quot; =&gt; [ &quot;RS256&quot; ] , &quot;issuer&quot; =&gt; &quot;https://auth.login.yahoo.co.jp/yconnect/v2&quot; , &quot;jwks_uri&quot; =&gt; &quot;https://auth.login.yahoo.co.jp/yconnect/v2/jwks&quot; , &quot;op_policy_uri&quot; =&gt; &quot;https://developer.yahoo.co.jp/yconnect/v2/guideline.html&quot; , &quot;op_tos_uri&quot; =&gt; &quot;https://developer.yahoo.co.jp/yconnect/v2/guideline.html&quot; , &quot;response_modes_supported&quot; =&gt; [ &quot;query&quot; , &quot;fragment&quot; ] , &quot;response_types_supported&quot; =&gt; [ &quot;code&quot; , &quot;token&quot; , &quot;id_token&quot; , &quot;code token&quot; , &quot;code id_token&quot; , &quot;token id_token&quot; , &quot;code token id_token&quot; ] , &quot;revocation_endpoint_auth_methods_supported&quot; =&gt; [ &quot;client_secret_basic&quot; ] , &quot;scopes_supported&quot; =&gt; [ &quot;openid&quot; , &quot;email&quot; , &quot;profile&quot; , &quot;address&quot; ] , &quot;service_documentation&quot; =&gt; &quot;https://developer.yahoo.co.jp/yconnect/&quot; , &quot;subject_types_supported&quot; =&gt; [ &quot;public&quot; ] , &quot;token_endpoint&quot; =&gt; &quot;https://auth.login.yahoo.co.jp/yconnect/v2/token&quot; , &quot;token_endpoint_auth_methods_supported&quot; =&gt; [ &quot;client_secret_post&quot; , &quot;client_secret_basic&quot; ] , &quot;ui_locales_supported&quot; =&gt; [ &quot;ja-JP&quot; ] , &quot;userinfo_endpoint&quot; =&gt; &quot;https://userinfo.yahooapis.jp/yconnect/v2/attribute&quot; } }","ref":"Oauth2MetadataUpdater.html#get_metadata/2","title":"Oauth2MetadataUpdater.get_metadata/2","type":"function"},{"doc":"Returns {:ok, value} of the metadata of an issuer, or {:error, error} if it could not be retrieved or if validation failed. Examples iex&gt; Oauth2MetadataUpdater . get_metadata_value ( &quot;https://accounts.google.com&quot; , &quot;authorization_endpoint&quot; , suffix : &quot;openid-configuration&quot; ) { :ok , &quot;https://accounts.google.com/o/oauth2/v2/auth&quot; } iex&gt; Oauth2MetadataUpdater . get_metadata_value ( &quot;https://accounts.google.com&quot; , &quot;token_endpoint&quot; , suffix : &quot;openid-configuration&quot; ) { :ok , &quot;https://oauth2.googleapis.com/token&quot; } iex&gt; Oauth2MetadataUpdater . get_metadata_value ( &quot;https://login.live.com&quot; , &quot;response_modes_supported&quot; , suffix : &quot;openid-configuration&quot; ) { :ok , [ &quot;query&quot; , &quot;fragment&quot; , &quot;form_post&quot; ] } iex&gt; Oauth2MetadataUpdater . get_metadata_value ( &quot;https://login.live.com&quot; , &quot;nonexisting_val&quot; , suffix : &quot;openid-configuration&quot; ) { :ok , nil } iex&gt; Oauth2MetadataUpdater . get_metadata_value ( &quot;https://openid-connect.onelogin.com/oidc&quot; , &quot;claims_supported&quot; , suffix : &quot;openid-configuration&quot; ) { :error , :invalid_http_response_code } iex&gt; Oauth2MetadataUpdater . get_metadata_value ( &quot;https://openid-connect.onelogin.com/oidc&quot; , &quot;claims_supported&quot; , suffix : &quot;openid-configuration&quot; , url_construction : :non_standard_append ) { :ok , [ &quot;acr&quot; , &quot;auth_time&quot; , &quot;company&quot; , &quot;custom_fields&quot; , &quot;department&quot; , &quot;email&quot; , &quot;family_name&quot; , &quot;given_name&quot; , &quot;groups&quot; , &quot;iss&quot; , &quot;locale_code&quot; , &quot;name&quot; , &quot;phone_number&quot; , &quot;preferred_username&quot; , &quot;sub&quot; , &quot;title&quot; , &quot;updated_at&quot; ] }","ref":"Oauth2MetadataUpdater.html#get_metadata_value/3","title":"Oauth2MetadataUpdater.get_metadata_value/3","type":"function"},{"doc":"OAuth2 and OpenID Connect metadata updater for Elixir Oauth2MetadataUpdater maintains an OAuth2 or OpenID Connect server's metadata up to date and performs the necessary validations. It also automatically adds the defaults values to the response. Implements the following standards: RFC8414 - OAuth 2.0 Authorization Server Metadata Except section 2.1 (Signed Authorization Server Metadata) OpenID Connect Discovery 1.0 incorporating errata set 1 Except section 2","ref":"readme.html","title":"Oauth2MetadataUpdater","type":"extras"},{"doc":"def deps do [ { :oauth2_metadata_updater , &quot;~&gt; 1.2&quot; } , { :hackney , &quot;~&gt; 1.0&quot; } ] end The hackney dependency is used as the default adapter for Tesla. Another one can be used instead (see https://github.com/teamon/tesla#adapters ) and then has to be configured in your config.exs : config :tesla , adapter : Tesla.Adapter.AnotherOne","ref":"readme.html#installation","title":"Oauth2MetadataUpdater - Installation","type":"extras"},{"doc":"Oauth2MetadataUpdater dynamically loads metadata (lazy-loading) and keeps it in memory for further access. Examples: iex&gt; Oauth2MetadataUpdater . get_metadata_value ( &quot;https://accounts.google.com&quot; , &quot;authorization_endpoint&quot; , suffix : &quot;openid-configuration&quot; ) { :ok , &quot;https://accounts.google.com/o/oauth2/v2/auth&quot; } iex&gt; Oauth2MetadataUpdater . get_metadata_value ( &quot;https://login.live.com&quot; , &quot;response_modes_supported&quot; , suffix : &quot;openid-configuration&quot; ) { :ok , [ &quot;query&quot; , &quot;fragment&quot; , &quot;form_post&quot; ] } iex&gt; Oauth2MetadataUpdater . get_metadata_value ( &quot;https://openid-connect.onelogin.com/oidc&quot; , &quot;claims_supported&quot; , suffix : &quot;openid-configuration&quot; , url_construction : :non_standard_append ) { :ok , [ &quot;acr&quot; , &quot;auth_time&quot; , &quot;company&quot; , &quot;custom_fields&quot; , &quot;department&quot; , &quot;email&quot; , &quot;family_name&quot; , &quot;given_name&quot; , &quot;groups&quot; , &quot;iss&quot; , &quot;locale_code&quot; , &quot;name&quot; , &quot;phone_number&quot; , &quot;preferred_username&quot; , &quot;sub&quot; , &quot;title&quot; , &quot;updated_at&quot; ] }","ref":"readme.html#usage","title":"Oauth2MetadataUpdater - Usage","type":"extras"},{"doc":"suffix : the well-know URI suffix as documented in the IANA registry . Defaults to &quot;openid-configuration&quot; refresh_interval : the number of seconds to keep metadata in cache before it is fetched again. Defaults to 3600 seconds min_refresh_interval : the delay before Oauth2MetadataUpdater will try to fetch metadata of an issuer again. It is intended to prevent fetching storms when the metadata is unavailable. Defaults to 10 seconds on_refresh_failure : determines the behaviour of Oauth2MetadataUpdater when the issuer metadata becomes unavailable: :keep_metadata will keep the metadata in the cache, :discard will delete the metadata. Defaults to :keep_metadata :tesla_middlewares : Tesla middlewares to add to the outgoing request url_construction : :standard (default) or :non_standard_append . Given the issuer &quot;https://www.example.com/auth&quot; the result URI would be: :standard : &quot;https://www.example.com/.well-known/oauth-authorization-server/auth&quot; :non_standard_append : &quot;https://www.example.com/auth/.well-known/oauth-authorization-server&quot; validation : in addition to the mandatory metadata values of the OAuth2 specification, OpenID Connect makes the jwks_uri , subject_types_supported and id_token_signing_alg_values_supported values mandatory. This option determines against which standard to validate: :oauth2 or :oidc . Defaults to :oidc The :suffix , :on_refresh_failure , :url_construction , :validation options shall be used unchanged for a given issuer between multiple calls, otherwise an exception will be raised.","ref":"readme.html#options","title":"Oauth2MetadataUpdater - Options","type":"extras"},{"doc":"See JWKSURIUpdater .","ref":"readme.html#loading-jwk-uris","title":"Oauth2MetadataUpdater - Loading JWK URIs","type":"extras"},{"doc":"All notable changes to this project will be documented in this file. The format is based on Keep a Changelog and this project adheres to Semantic Versioning.","ref":"changelog.html","title":"CHANGELOG","type":"extras"},{"doc":"Changed [Oauth2MetadataUpdater] Relax dep requirements","ref":"changelog.html#1-2-2-2023-07-05","title":"CHANGELOG - [1.2.2] - 2023-07-05","type":"extras"},{"doc":"Changed [Oauth2MetadataUpdater] :suffix option now defaults to &quot;openid-configuration&quot; [Oauth2MetadataUpdater] :validation option now defaults to :oidc","ref":"changelog.html#0-2-0-2020-05-24","title":"CHANGELOG - [0.2.0] - 2020-05-24","type":"extras"}]